// Auto-generated. Do not edit!

// (in-package mesh_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let TriangleMesh = require('./TriangleMesh.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class TriangleMeshStamped {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.mesh = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('mesh')) {
        this.mesh = initObj.mesh
      }
      else {
        this.mesh = new TriangleMesh();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type TriangleMeshStamped
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [mesh]
    bufferOffset = TriangleMesh.serialize(obj.mesh, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type TriangleMeshStamped
    let len;
    let data = new TriangleMeshStamped(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [mesh]
    data.mesh = TriangleMesh.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += TriangleMesh.getMessageSize(object.mesh);
    return length;
  }

  static datatype() {
    // Returns string type for a message object
    return 'mesh_msgs/TriangleMeshStamped';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '3e766dd12107291d682eb5e6c7442b9d';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    std_msgs/Header header
    mesh_msgs/TriangleMesh mesh
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: mesh_msgs/TriangleMesh
    ## Definition of a triangle mesh
    
    TriangleIndices[] triangles # list of triangles; the index values refer to positions in vertices (and vertex_normals, if given)
    geometry_msgs/Point[] vertices # the actual vertices that make up the mesh
    #optional:
    geometry_msgs/Point[] vertex_normals
    std_msgs/ColorRGBA[] vertex_colors
    std_msgs/ColorRGBA[] triangle_colors
    geometry_msgs/Point[] vertex_texture_coords
    mesh_msgs/MeshMaterial[] face_materials
    sensor_msgs/Image[] textures
    mesh_msgs/MeshFaceCluster[] clusters
    
    ================================================================================
    MSG: mesh_msgs/TriangleIndices
    # Definition of a triangle's vertices
    uint32[3] vertex_indices
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: std_msgs/ColorRGBA
    float32 r
    float32 g
    float32 b
    float32 a
    
    ================================================================================
    MSG: mesh_msgs/MeshMaterial
    uint32 texture_index
    std_msgs/ColorRGBA color
    bool has_texture
    
    ================================================================================
    MSG: sensor_msgs/Image
    # This message contains an uncompressed image
    # (0, 0) is at top-left corner of image
    #
    
    Header header        # Header timestamp should be acquisition time of image
                         # Header frame_id should be optical frame of camera
                         # origin of frame should be optical center of camera
                         # +x should point to the right in the image
                         # +y should point down in the image
                         # +z should point into to plane of the image
                         # If the frame_id here and the frame_id of the CameraInfo
                         # message associated with the image conflict
                         # the behavior is undefined
    
    uint32 height         # image height, that is, number of rows
    uint32 width          # image width, that is, number of columns
    
    # The legal values for encoding are in file src/image_encodings.cpp
    # If you want to standardize a new string format, join
    # ros-users@lists.sourceforge.net and send an email proposing a new encoding.
    
    string encoding       # Encoding of pixels -- channel meaning, ordering, size
                          # taken from the list of strings in include/sensor_msgs/image_encodings.h
    
    uint8 is_bigendian    # is this data bigendian?
    uint32 step           # Full row length in bytes
    uint8[] data          # actual matrix data, size is (step * rows)
    
    ================================================================================
    MSG: mesh_msgs/MeshFaceCluster
    #Cluster
    uint32[] face_indices
    #optional
    string label
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new TriangleMeshStamped(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.mesh !== undefined) {
      resolved.mesh = TriangleMesh.Resolve(msg.mesh)
    }
    else {
      resolved.mesh = new TriangleMesh()
    }

    return resolved;
    }
};

module.exports = TriangleMeshStamped;
